OpenVDB 11.0.0

Loading...
Searching...
No Matches
BoxStencil< GridT > Class Template Reference

`#include <nanovdb/util/Stencils.h>`

Inheritance diagram for BoxStencil< GridT >:

## Public Types
using | GridType = GridT
using | TreeType = typename GridT::TreeType
using | ValueType = typename GridT::ValueType
using | AccessorType

## Public Member Functions
__hostdev__ | BoxStencil (const GridType &grid)
template<int i, int j, int k>
__hostdev__ unsigned int | pos () const
| Return linear offset for the specified stencil point relative to its center.
__hostdev__ bool | intersects (ValueType isoValue=ValueType(0)) const
| Return true if the center of the stencil intersects the.
__hostdev__ ValueType | interpolation (const Vec3< ValueType > &xyz) const
| Return the trilinear interpolation at the normalized position.
__hostdev__ Vec3< ValueType > | gradient (const Vec3< ValueType > &xyz) const
| Return the gradient in world space of the trilinear interpolation kernel.
__hostdev__ void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.
__hostdev__ const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos.
__hostdev__ void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil.
__hostdev__ ValueType | mean () const
| Return the mean value of the current stencil.
__hostdev__ ValueType | min () const
| Return the smallest value in the stencil buffer.
__hostdev__ ValueType | max () const
| Return the largest value in the stencil buffer.
__hostdev__ const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil.
__hostdev__ const ValueType & | getCenterValue () const
| Return the value at the center of the stencil.
__hostdev__ bool | intersects (const ValueType &isoValue=ValueType(0)) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue.
__hostdev__ Mask | intersectionMask (ValueType isoValue=ValueType(0)) const
| Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.
__hostdev__ const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed.
__hostdev__ const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil.

## Static Public Member Functions
static __hostdev__ int | size ()
| Return the size of the stencil buffer.

## Static Public Attributes
static constexpr int | SIZE = 8

## Protected Attributes
const GridType * | mGrid

## Friends
template<typename, int, typename>
class | BaseStencil

## Member Typedef Documentation

## ◆ AccessorType

using AccessorType
| inherited

## ◆ GridType

template<typename GridT>

using GridType = GridT

## ◆ TreeType

template<typename GridT>

using TreeType = typename GridT::TreeType

## ◆ ValueType

template<typename GridT>

using ValueType = typename GridT::ValueType

## Constructor & Destructor Documentation

## ◆ BoxStencil()

template<typename GridT>

__hostdev__ BoxStencil | ( | const GridType & | grid | ) |
| inline

## Member Function Documentation

## ◆ accessor()

__hostdev__ const AccessorType & accessor | ( |  | ) | const
| inline inherited

Return a const reference to the ValueAccessor associated with this Stencil.

## ◆ getCenterCoord()

__hostdev__ const Coord & getCenterCoord | ( |  | ) | const
| inline inherited

Return the coordinates of the center point of the stencil.

## ◆ getCenterValue()

__hostdev__ const ValueType & getCenterValue | ( |  | ) | const
| inline inherited

Return the value at the center of the stencil.

## ◆ getValue()

__hostdev__ const ValueType & getValue | ( | unsigned int | pos = 0 | ) | const
| inline inherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## ◆ gradient()

template<typename GridT>

__hostdev__ Vec3< ValueType > gradient | ( | const Vec3< ValueType > & | xyz | ) | const
| inline

Return the gradient in world space of the trilinear interpolation kernel.

Parameters

  xyz | Floating point coordinate position.

Warning
  It is assumed that the stencil has already been moved to the relevant voxel position, e.g. using moveTo(xyz).

Note
  Computed as partial derivatives of the trilinear interpolation kernel: v000 (1-u)(1-v)(1-w) + v001 (1-u)(1-v)w + v010 (1-u)v(1-w) + v011 (1-u)vw
  - v100 u(1-v)(1-w) + v101 u(1-v)w + v110 uv(1-w) + v111 uvw

## ◆ grid()

__hostdev__ const GridType & grid | ( |  | ) | const
| inline inherited

Return a const reference to the grid from which this stencil was constructed.

## ◆ interpolation()

template<typename GridT>

__hostdev__ ValueType interpolation | ( | const Vec3< ValueType > & | xyz | ) | const
| inline

Return the trilinear interpolation at the normalized position.

Parameters

  xyz | Floating point coordinate position. Index space and NOT world space.

Warning
  It is assumed that the stencil has already been moved to the relevant voxel position, e.g. using moveTo(xyz).

Note
  Trilinear interpolation kernal reads as: v000 (1-u)(1-v)(1-w) + v001 (1-u)(1-v)w + v010 (1-u)v(1-w) + v011 (1-u)vw
  - v100 u(1-v)(1-w) + v101 u(1-v)w + v110 uv(1-w) + v111 uvw

## ◆ intersectionMask()

__hostdev__ Mask intersectionMask | ( | ValueType | isoValue = ValueType(0) | ) | const
| inline inherited

Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use (mask & (1u<<2)) where mask is ther return value from this function. To check if there are any intersections use mask!=0u, and for no intersections use mask==0u. To count the number of intersections use __builtin_popcount(mask).

## ◆ intersects() [1/2]

__hostdev__ bool intersects | ( | const ValueType & | isoValue = ValueType(0) | ) | const
| inline inherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## ◆ intersects() [2/2]

template<typename GridT>

__hostdev__ bool intersects | ( | ValueType | isoValue = ValueType(0) | ) | const
| inline

Return true if the center of the stencil intersects the.

iso-contour specified by the isoValue

## ◆ max()

__hostdev__ ValueType max | ( |  | ) | const
| inline inherited

Return the largest value in the stencil buffer.

## ◆ mean()

__hostdev__ ValueType mean | ( |  | ) | const
| inline inherited

Return the mean value of the current stencil.

## ◆ min()

__hostdev__ ValueType min | ( |  | ) | const
| inline inherited

Return the smallest value in the stencil buffer.

## ◆ moveTo()

__hostdev__ void moveTo | ( | const Coord & | ijk | ) |
| inline inherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## ◆ pos()

template<typename GridT>
template<int i, int j, int k>

__hostdev__ unsigned int pos | ( |  | ) | const
| inline

Return linear offset for the specified stencil point relative to its center.

## ◆ setValue()

__hostdev__ void setValue | ( | const ValueType & | value | ) |
| inline inherited

Set the value at the specified location relative to the center of the stencil.

## ◆ size()

__hostdev__ int size | ( |  | ) |
| inline static inherited

Return the size of the stencil buffer.

## Friends And Related Symbol Documentation

## ◆ BaseStencil

template<typename GridT>
template<typename, int, typename>

friend class BaseStencil
| friend

## Member Data Documentation

## ◆ mGrid

const GridType* mGrid
| protected inherited

## ◆ SIZE

template<typename GridT>

int SIZE = 8
| static constexpr